
/*SE HA CREADO UNA CONEXIN EN sqlplus developer  PARA ORACLE 11G EXPRESS EDITION CONECTANDONOS CON EL USUARIO INMODBA */

--- Creacin de la tabla CLIENTES
prompt Creando la tabla Clientes.....
CREATE TABLE CLIENTES
(
  CODIGO_CLIENTE  VARCHAR2(20 BYTE) NOT NULL,
  NOMBRE          VARCHAR2(100 BYTE) NOT NULL,
  DIRECCION       VARCHAR2(100 BYTE) NOT NULL,
  CIF             VARCHAR2(20 BYTE) NOT NULL,
  TELEFONO        VARCHAR2(40 BYTE),
  EMAIL           VARCHAR2(100 BYTE),
  ESTADO	  VARCHAR2(6 BYTE),

  CONSTRAINT PK_CLIENTES PRIMARY KEY (CODIGO_CLIENTE),
  CONSTRAINT CLIENTES_CHK1 CHECK (ESTADO IN ('ALTA','BAJA'))
)
TABLESPACE INMODBS
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;

-- Creacin de la tabla Empleados
prompt Creando la tabla Empleados ......
CREATE TABLE EMPLEADOS
(
  CODIGO_EMPLEADO      VARCHAR2(20 BYTE) NOT NULL,
  NOMBRE               VARCHAR2(100 BYTE) NOT NULL,
  DIRECCION            VARCHAR2(100 BYTE) NOT NULL,
  DOCUMENTO_IDENTIDAD  VARCHAR2(20 BYTE) NOT NULL,
  FECHA_NACIMIENTO     DATE,
  EMAIL_PROFESIONAL    VARCHAR2(100 BYTE),
  ESTADO 		VARCHAR2(6 BYTE) NOT NULL,
  CONSTRAINT PK_EMPLEADOS PRIMARY KEY (CODIGO_EMPLEADO),
  CONSTRAINT EMPLEADOS_CHK1 CHECK (ESTADO IN ('ALTA','BAJA'))

  
)
TABLESPACE INMODBS
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


-- Creacin de la tabla Sedes
prompt Creando la tabla Sedes ......             
 CREATE TABLE SEDES
(
  CODIGO_SEDE         VARCHAR2(20 BYTE) NOT NULL,
  PAIS                VARCHAR2(40 BYTE) NOT NULL,
  ZONA                VARCHAR2(40 BYTE),
  PROVINCIA           VARCHAR2(40 BYTE),
  POBLACION           VARCHAR2(40 BYTE) NOT NULL,
  DIRECCION           VARCHAR2(100 BYTE) NOT NULL,
  FECHA_INAUGURACION  DATE,
  RESPONSABLE         VARCHAR2(20 BYTE) NOT NULL,
  ESTADO	      VARCHAR2(6 BYTE) NOT NULL,

  CONSTRAINT PK_SEDES PRIMARY KEY (CODIGO_SEDE),
  CONSTRAINT SEDES_CHK1 CHECK (ESTADO IN ('ALTA','BAJA')),

  CONSTRAINT SEDES_EMPLEADOS_FK
    FOREIGN KEY (RESPONSABLE)
    REFERENCES EMPLEADOS (CODIGO_EMPLEADO)


)
TABLESPACE INMODBS
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


-- Creacin de la tabla Puestos de Trabajo
prompt Creando la tabla Puestos de Trabajo....

 CREATE TABLE PUESTOS_TRABAJO
(
  CODIGO_PUESTO     VARCHAR2(20 BYTE) NOT NULL,
  DESCRIPCION       VARCHAR2(50 BYTE) NOT NULL,
  
  CONSTRAINT PK_PUESTOS_TRABAJO PRIMARY KEY (CODIGO_PUESTO) 
)  
TABLESPACE INMODBS
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;

-- Creacin de la tabla Empleados de la Sede
 prompt Creando la tabla Empleados de la Sede....            

 CREATE TABLE EMPLEADOS_SEDES
(
  CODIGO_EMPLEADO         VARCHAR2(20 BYTE) NOT NULL,
  CODIGO_SEDE             VARCHAR2(20 BYTE) NOT NULL,
  CODIGO_PUESTO_TRABAJO   VARCHAR2(20 BYTE) NOT NULL,
  FECHA_ALTA              DATE NOT NULL,
  JORNADA                 VARCHAR2(10 BYTE) NOT NULL,
  SUPERIOR_JERARQUICO     VARCHAR2(20 BYTE),
  FECHA_BAJA		  DATE,	

  CONSTRAINT PK_EMPLEADOS_SEDES PRIMARY KEY (CODIGO_EMPLEADO,CODIGO_SEDE),

  CONSTRAINT EMPLEADOS_SEDE_EMPLEADOS_FK
    FOREIGN KEY (CODIGO_EMPLEADO)
    REFERENCES EMPLEADOS (CODIGO_EMPLEADO),

  CONSTRAINT EMPLEADOS_SEDE_SEDE_FK
    FOREIGN KEY (CODIGO_SEDE)
    REFERENCES SEDES (CODIGO_SEDE),
 
  CONSTRAINT EMPLEADOS_SEDE_PUESTOS_FK
    FOREIGN KEY (CODIGO_PUESTO_TRABAJO)
    REFERENCES PUESTOS_TRABAJO (CODIGO_PUESTO),

 CONSTRAINT EMPLEADOS_SEDES_CHK1 CHECK (JORNADA IN ('COMPLETA','MAANA','TARDE'))


)
TABLESPACE INMODBS
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


-- Creacin de la tabla Tipo de Inmueble
prompt Creando la tabla Tipo de Inmueble......
 CREATE TABLE TIPO_INMUEBLE
(
  CODIGO_TIPO       VARCHAR2(20 BYTE) NOT NULL,
  DESCRIPCION       VARCHAR2(50 BYTE) NOT NULL,
  
  CONSTRAINT PK_TIPO_INMUEBLE PRIMARY KEY (CODIGO_TIPO) 
)  
TABLESPACE INMODBS
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;

-- Creacin de la tabla Tipo de actuacin del inmueble
prompt Creando la tabla Tipo de Actuacin del Inmueble
CREATE TABLE TIPO_ACTUACION_INMUEBLE
(
  CODIGO_TIPO_ACTUACION       VARCHAR2(20 BYTE) NOT NULL,
  DESCRIPCION                 VARCHAR2(50 BYTE) NOT NULL,
  
  CONSTRAINT PK_TIPO_ACT_INMUEBLE PRIMARY KEY (CODIGO_TIPO_ACTUACION) 
)  
TABLESPACE INMODBS
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;

--Creacin tabla Inmuebles
prompt Creando la tabla inmuebles.......
CREATE TABLE INMUEBLES
(
  CODIGO_INMUEBLE     VARCHAR2(20 BYTE) NOT NULL,
  PAIS                VARCHAR2(40 BYTE) NOT NULL,
  ZONA                VARCHAR2(40 BYTE),
  PROVINCIA           VARCHAR2(40 BYTE),
  POBLACION           VARCHAR2(40 BYTE) NOT NULL,
  CODIGO_POSTAL       VARCHAR2(20 BYTE),
  DIRECCION           VARCHAR2(100 BYTE) NOT NULL,
  COORDENADAS_MAP     VARCHAR2(50),
  FECHA_CONSTRUCCION  DATE,
  FECHA_ENTRADA       DATE NOT NULL,
  PROPIETARIO         VARCHAR2(20 BYTE),
  TIPO_INMUEBLE       VARCHAR2(20 BYTE) NOT NULL,
  CARACTERISTICAS     VARCHAR2(200 BYTE),
  ESTADO	      VARCHAR2(6 BYTE) NOT NULL,	

 CONSTRAINT PK_INMUEBLES PRIMARY KEY (CODIGO_INMUEBLE),

 CONSTRAINT INMUEBLES_TIPO_INM_FK
    FOREIGN KEY (TIPO_INMUEBLE)
    REFERENCES TIPO_INMUEBLE (CODIGO_TIPO),

 CONSTRAINT INMUEBLES_CLIENTES_FK
    FOREIGN KEY (PROPIETARIO)
    REFERENCES CLIENTES (CODIGO_CLIENTE),
 
CONSTRAINT INMUEBLES_CHK1 CHECK (ESTADO IN ('ALTA','BAJA'))

)
TABLESPACE INMODBS
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;

 
--Creacin de la tabla imagenes                             
rem Creando la tabla IMAGENES....

CREATE TABLE IMAGENES
(
  CODIGO_IMAGEN       VARCHAR2(20 BYTE) NOT NULL,
  RUTA		      VARCHAR2(50 BYTE) NOT NULL,
  NOMBRE              VARCHAR2(20 BYTE) NOT NULL,
  CODIGO_INMUEBLE     VARCHAR2(20 BYTE) NOT NULL,

CONSTRAINT PK_IMAGENES PRIMARY KEY (CODIGO_IMAGEN),

 CONSTRAINT IMAGEN_INMUEBLES_FK
    FOREIGN KEY (CODIGO_INMUEBLE)
    REFERENCES INMUEBLES (CODIGO_INMUEBLE)
  
)
TABLESPACE INMODBS
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;

-- Creacin tabla actuaciones inmuebles  
 prompt Creando la tabla Actuaciones Inmuebles....                           
CREATE TABLE ACTUACIONES_INMUEBLES
(
  CODIGO_ACTUACION        VARCHAR2(20 BYTE) NOT NULL,
  CODIGO_TIPO_ACTUACION   VARCHAR2(20 BYTE) NOT NULL,
  CODIGO_PROPIETARIO      VARCHAR2 (20 BYTE) NOT NULL,
  CODIGO_INTERESADO       VARCHAR2 (20 BYTE),
  CODIGO_EMPLEADO         VARCHAR2(20 BYTE) NOT NULL,
  FECHA_ALTA              DATE NOT NULL,
  FECHA_FINALIZACION      DATE,
  SITUACION               VARCHAR2(100 BYTE),
  COD_INMUEBLE            VARCHAR2(20 BYTE) NOT NULL,
  IMPORTE_ACTUACION       NUMBER,
  OBSERVACIONES           VARCHAR2(200 BYTE),

  CONSTRAINT PK_ACTUACIONES_INMUEBLES PRIMARY KEY(CODIGO_ACTUACION),

  CONSTRAINT ACTUACIONES_INM_TIPO_ACT_FK
    FOREIGN KEY (CODIGO_TIPO_ACTUACION)
    REFERENCES TIPO_ACTUACION_INMUEBLE (CODIGO_TIPO_ACTUACION),

  CONSTRAINT ACTUACIONES_INM_CLIENTES_FK
    FOREIGN KEY (CODIGO_PROPIETARIO)
    REFERENCES CLIENTES (CODIGO_CLIENTE),

  CONSTRAINT ACTUACIONES_INM_CLIENTES_FK2
    FOREIGN KEY (CODIGO_INTERESADO)
    REFERENCES CLIENTES (CODIGO_CLIENTE),

  CONSTRAINT ACTUACIONES_INM_EMP_FK
    FOREIGN KEY (CODIGO_EMPLEADO)
    REFERENCES EMPLEADOS (CODIGO_EMPLEADO),

  CONSTRAINT ACTUACIONES_INM_CHK1 CHECK (SITUACION IN 
  ('INICIADA','EN CURSO','ACEPTADA','RECHAZADA','FINALIZADA'))

 
)
TABLESPACE INMODBS
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


--Creacin de la tabla TIPO_PROPUESTAS
prompt Creando tabla Tipo de Propuestas

CREATE TABLE TIPO_PROPUESTAS
(
  CODIGO_TIPO_PROPUESTA       VARCHAR2(20 BYTE) NOT NULL,
  DESCRIPCION                 VARCHAR2(50 BYTE) NOT NULL,
  
  CONSTRAINT PK_TIPO_PROPUESTA PRIMARY KEY (CODIGO_TIPO_PROPUESTA) 
)  
TABLESPACE INMODBS
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;
                                       
-- Creacin tabla PROPUESTAS
prompt Creando tabla Propuestas....

CREATE TABLE PROPUESTAS
(
  CODIGO_PROPUESTA    VARCHAR2(20 BYTE) NOT NULL,
  CODIGO_EMPLEADO     VARCHAR2(20 BYTE) NOT NULL,
  CODIGO_TIPO_PROPUESTA   VARCHAR2(20 BYTE) NOT NULL,
  FECHA_PROPUESTA      DATE NOT NULL,
  CODIGO_ACTUACION_INM VARCHAR2(20 BYTE) NOT NULL,
  ESTADO               VARCHAR2(20 BYTE) NOT NULL,
  OBSERVACIONES        VARCHAR2(200 BYTE),
  IMPORTE	       NUMBER,
  
  CONSTRAINT PK_PROPUESTAS  PRIMARY KEY (CODIGO_PROPUESTA),

  CONSTRAINT PROPUESTAS_EMPLEADOS_FK
    FOREIGN KEY (CODIGO_EMPLEADO)
    REFERENCES EMPLEADOS (CODIGO_EMPLEADO),

  CONSTRAINT PROPUESTAS_TIPO_PRO_FK
    FOREIGN KEY (CODIGO_TIPO_PROPUESTA)
    REFERENCES TIPO_PROPUESTAS (CODIGO_TIPO_PROPUESTA),

  CONSTRAINT PROPUESTAS_ACTUACIONES_INM_FK
    FOREIGN KEY (CODIGO_ACTUACION_INM)
    REFERENCES ACTUACIONES_INMUEBLES (CODIGO_ACTUACION),

  CONSTRAINT PROPUESTAS_CHK1 CHECK (ESTADO IN ('PRESENTADA','EN CURSO','ACEPTADA','RECHAZADA','BAJA'))

)
TABLESPACE INMODBS
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


-- Creacin de la tabla Proveedores
prompt Creando tabla Proveedores
CREATE TABLE PROVEEDORES
(
  CODIGO_PROVEEDOR     VARCHAR2(20 BYTE) NOT NULL,
  NOMBRE               VARCHAR2(100 BYTE) NOT NULL,
  DIRECCION            VARCHAR2(100 BYTE) NOT NULL,
  CIF                  VARCHAR2(20 BYTE) NOT NULL,
  TELEFONO             VARCHAR2(40 BYTE),
  EMAIL                VARCHAR2(100 BYTE),
  ESTADO		VARCHAR2(6 BYTE) NOT NULL,
  CONSTRAINT PK_PROVEEDORES PRIMARY KEY (CODIGO_PROVEEDOR),
  CONSTRAINT PROVEEDOR_CHK1 CHECK (ESTADO IN ('ALTA','BAJA'))

  
)
TABLESPACE INMODBS
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


--Creacin tabla 
prompt Creando tabla TIPO ACTUACION PROVEEDOR....
CREATE TABLE TIPO_ACTUACION_PROVEEDOR
(
  CODIGO_TIPO_ACT_PROV        VARCHAR2(20 BYTE) NOT NULL,
  DESCRIPCION                 VARCHAR2(50 BYTE) NOT NULL,
  
  CONSTRAINT PK_TIPO_ACT_PROVEEDOR PRIMARY KEY (CODIGO_TIPO_ACT_PROV) 
)  
TABLESPACE INMODBS
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;
                       


--Creacin tabla Actuaciones Proveedores
prompt Creando Tabla Actuaciones Proveedores.....

CREATE TABLE ACTUACIONES_PROVEEDORES

(
  CODIGO_ACTUACION_PRO        VARCHAR2(20 BYTE) NOT NULL,
  CODIGO_TIPO_ACTUACION_PRO   VARCHAR2(20 BYTE) NOT NULL,
  CODIGO_PROVEEDOR            VARCHAR2 (20 BYTE) NOT NULL,
  CODIGO_EMPLEADO             VARCHAR2 (20 BYTE) NOT NULL,
  FECHA_ALTA_ACTUACION        DATE NOT NULL,
  FECHA_FINALIZACION          DATE,
  SITUACION                   VARCHAR2(100 BYTE),
  CODIGO_ACTUACION_INMO      VARCHAR2(20 BYTE) NOT NULL,
  OBSERVACIONES 	      VARCHAR2(200 BYTE),

  CONSTRAINT PK_ACTUACIONES_PROVEEDORES PRIMARY KEY(CODIGO_ACTUACION_PRO),

  CONSTRAINT ACTUACIONES_PROV_TIPO_ACT_FK
    FOREIGN KEY (CODIGO_TIPO_ACTUACION_PRO)
    REFERENCES TIPO_ACTUACION_PROVEEDOR (CODIGO_TIPO_ACT_PROV),

  CONSTRAINT ACTUACIONES_PROV_PROV_FK
    FOREIGN KEY (CODIGO_PROVEEDOR)
    REFERENCES PROVEEDORES (CODIGO_PROVEEDOR),

  CONSTRAINT ACTUACIONES_PROV_EMP_FK
    FOREIGN KEY (CODIGO_EMPLEADO)
    REFERENCES EMPLEADOS (CODIGO_EMPLEADO),

  CONSTRAINT ACTUACIONES_PROV_ACT_INM_FK
    FOREIGN KEY (CODIGO_ACTUACION_INMO)
    REFERENCES ACTUACIONES_INMUEBLES (CODIGO_ACTUACION),

 CONSTRAINT ACTTUACION_PROV_CHK1 CHECK ( SITUACION IN
 ('INICIADA','EN CURSO','ACEPTADA','RECHAZADA','FINALIZADA'))

  
)
TABLESPACE INMODBS
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;

 ---Creacin de la tabla LOGS
prompt Creando la tabla de LOGS.....
CREATE TABLE INMO_LOGS
(
  COD_LOG         NUMBER,
  FECHA_LOG       DATE,
  FUNCION_LOG     VARCHAR2(100 BYTE),
  PARAM_IN_LOG    VARCHAR2(1000 BYTE),
  PARAM_OUT_LOG   VARCHAR2(1000 BYTE),
  USUARIO_LOG     VARCHAR2(100 BYTE)

 )
TABLESPACE INMODBS
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;

