--- Creacin de la tabla inmuebles a alquilar
prompt Creando tabla Inmuebles a Alquilar...........

CREATE TABLE DWH_INMUEBLES_ALQUILAR
(
  ID              NUMBER,
  ANIO            VARCHAR2(4 BYTE),
  NUM_INMUEBLES_ALQUILAR  NUMBER,
  NUM_INMUEBLES_ALQUILADOS NUMBER,

  CONSTRAINT PK_INMUEBLES_ALQUILAR PRIMARY KEY (ID)

)
TABLESPACE INMODBS
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;

-- Creacin de la tabla Propuestas Aceptadas
prompt Creando tabla Propuestas Aceptadas.......

CREATE TABLE DWH_PROPUESTAS_ACEPTADAS
(
  ID              NUMBER,
  ANIO            VARCHAR2(4 BYTE),
  FECHA_ALTA      DATE,
  COD_EMPLEADO    VARCHAR2(20 BYTE),
  PROPUESTAS_ACEPTADAS NUMBER,
  NUM_PROPUESTAS  NUMBER,
  TOTAL_ACEPTADAS NUMBER,
  NUM_TOTAL_PROPUESTAS NUMBER,
  IMPORTE_TOTAL NUMBER,

  CONSTRAINT PK_PROPUESTAS_ACEPTADAS PRIMARY KEY (ID)

)
TABLESPACE INMODBS
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;

---Creacin de la tabla transacciones visitas
Prompt Creando tabla Transacciones y Visitas.............

CREATE TABLE DWH_TRANSACCIONES_VISITAS
(
  ID              NUMBER,
  ANIO            VARCHAR2(4 BYTE),
  COD_SEDE       VARCHAR2(20 BYTE),
  COD_EMPLEADO    VARCHAR2(20 BYTE),
  TIPO_ACTUACION  VARCHAR2(20 BYTE),
  NUM_ACT_VISITAS NUMBER,
  NUM_TRANSACCIONES  NUMBER,
  COD_SEDE_MAX    VARCHAR2(20),
  COD_EMPLEADO_MAX VARCHAR2(20),
  TOTAL_TRAN       NUMBER,
  TOTAL_VISITAS    NUMBER,

  CONSTRAINT PK_TRANSACCIONES_VISITAS PRIMARY KEY (ID)

)
TABLESPACE INMODBS
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


---Creacin tabla Porcentaje Proveedores
prompt Creando tabla Porcentaje de Proveedores.............

CREATE TABLE DWH_PORCENTAJE_PROVEEDORES
(
  ID              NUMBER,
  ANIO            VARCHAR2(4 BYTE),
  MES             VARCHAR2(20 BYTE),
  NUM_ACTUACIONES NUMBER,
  ANIO_ANTERIOR   VARCHAR2(4 BYTE),
  NUM_ACTUACIONES_ANTERIOR NUMBER, 

  CONSTRAINT PK_PORCENTAJE_PROVEEDORES PRIMARY KEY (ID)

)
TABLESPACE INMODBS
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;



-- Creacin de la tabla porcentaje Transacciones

prompt Creando tabla Porcentaje de Transacciones..............
CREATE TABLE DWH_PORCENTAJE_TRANSACCIONES
(
  ID              NUMBER,
  ANIO            VARCHAR2(4 BYTE),
  PAIS            VARCHAR2(20 BYTE),
  COD_SEDE        VARCHAR2(20 BYTE),
  NUM_TRAN_SEDE_ANIO  NUMBER,
  NUM_TOTAL_TRAN      NUMBER,
  NUM_TOTAL_PAIS      NUMBER,
  PAIS_MAYOR      VARCHAR2(20 BYTE),

  CONSTRAINT PK_PORCENTAJE_TRANSACCIONES PRIMARY KEY (ID)

)
TABLESPACE INMODBS
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;

---Porcentaje posterior venta
Prompt Creando tabla porcentaje ventas............................
CREATE TABLE DWH_PORCENTAJE_POSTERIOR_VENTA
(
  ID                 NUMBER,
  ANIO               VARCHAR2(4 BYTE),
  NUM_VENDIDOS_POST  NUMBER,
  NUM_TOTAL          NUMBER,

  CONSTRAINT PK_PORCENTAJE_POSTERIOR_VENTA PRIMARY KEY (ID)

)
TABLESPACE INMODBS
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


-- Creacin tabla tipo inmueble ms alquilado
prompt Creando tabla Tipo de Inmueble ms alquilado....................
CREATE TABLE DWH_TIPOINMUEBLE_MASALQUILADO
(
  ID                 NUMBER,
  PAIS               VARCHAR2(20 BYTE),
  TIPO_INMUEBLE      VARCHAR2(20 BYTE),
  NUM_TOTAL_ALQUILERES  NUMBER,
  DESCRIPCION          VARCHAR2 (200 BYTE),

  CONSTRAINT PK_TIPO_INM_MASALQUILADO PRIMARY KEY (ID)

)
TABLESPACE INMODBS
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;

--Creacion Tabla personas contratadas por paises
Prompt Creando Tabla de Empleados Contratados por paises...............
CREATE TABLE DWH_CONTRATADOS_PAISES
(
  ID                 NUMBER,
  PAIS               VARCHAR2(20 BYTE),
  NUM_TOTAL_CONTRATADOS  NUMBER,

  CONSTRAINT PK_CONTRATADOS_PAISES PRIMARY KEY (ID)

)
TABLESPACE INMODBS
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;

-- Creacin tabla Litigios Jurdicos
Prompt Creando tabla de nmero de Litigios Jurdicos..............
CREATE TABLE DWH_LITIGIOS_JURIDICOS
(
  ID                 NUMBER,
  COD_CLIENTE        VARCHAR2(20 BYTE),
  NUM_TOTAL_LITIGIOS NUMBER,
  ES_MAYOR           VARCHAR2(20 BYTE),

  CONSTRAINT PK_LITIGIOS_JURIDICOS PRIMARY KEY (ID)

)
TABLESPACE INMODBS
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;

-- Creacin tabla facturacin cliente
Prompt Creando tabla de Facturacin al Cliente...............
CREATE TABLE DWH_FACTURACION_CLIENTE
(
  ID                 NUMBER,
  ANIO               VARCHAR2(4 BYTE),
  COD_CLIENTE        VARCHAR2(20 BYTE),
  IMPORTE_TOTAL      NUMBER,
  MAYOR_FAC          VARCHAR2(20 BYTE),

  CONSTRAINT PK_FACTURACION_CLIENTE PRIMARY KEY (ID)

)
TABLESPACE INMODBS
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;

--Creacin tabla inmuebles disponibles
Prompt Creando tabla de Inmuebles Disponibles...............
CREATE TABLE DWH_INMUEBLES_DISPONIBLES
(
  ID                 NUMBER,
  COD_SEDE           VARCHAR2(20 BYTE),
  NUM_TOTAL_INMUEBLES  NUMBER,

  CONSTRAINT PK_INMUEBLES_DISPONIBLES PRIMARY KEY (ID)

)
TABLESPACE INMODBS
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;

prompt Creando la tabla mayor pais venta de inmuebles..............

CREATE TABLE DWH_MAXIMOS_PAIS_INMUEBLE 
(
  MAXTOTAL NUMBER ,
  PAIS VARCHAR2(20 BYTE) 
 
) 
TABLESPACE INMODBS
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;

prompt Creando la tabla propuestas presentadas aceptadas..............

CREATE TABLE DWH_PRESENTADAS_ACEPTADAS
(
  COD_EMPLEADO VARCHAR2(20) ,
  RATIO        NUMBER,
  MAYOR        VARCHAR2(20)
) 
TABLESPACE INMODBS
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;



prompt Creando la tabla importe de propuestas aceptadas................

CREATE TABLE DWH_IMPORTE_ACEPTADAS
(
  ANIO         VARCHAR2(4) ,
  IMPORTE_TOTAL    NUMBER

) 
TABLESPACE INMODBS
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;

