Prompt Creando especificacin del Paquete INMO_MOD_GENERAL...........

create or replace PACKAGE INMO_MOD_GENERAL AS 
/*Este paquete contiene los procedimientos y funciomes necesarios de las tablas correspondientes al mantenimiento
del Mdulo General: CLIENTES,SEDES,INMUEBLES,ACTUACIONES_INMUEBLES */


/*Descripcin:  	Alta Nuevo Cliente

Parmetros de entrada:          
				inmo_nombre       nombre del cliente
                                inmo_direccion    direccin del cliente
				inmo_cif          cif del cliente
                                inmo_tef          telefono del cliente
                                inmo_email        email del cliente
				
Parmetros de salida
				RSP
				En caso de insercin con xito retorna el cdigo del cliente,
                                Si el cliente existe dispara una excpcin

				
Tareas del procedimiento
				Se da de alta el cliente 
				Se registra accin en la tabla LOG
				Devuelve Si todo ha ido bien:
					RSP = 'OK: Alta cliente con su cdigo
				Mensajes de error:
				'ERROR: hay campos obligatorios sin rellenar'
				'ERROR: El cliente ya existe en el sistema' */
				

PROCEDURE INMO_ALTA_CLIENTES (
                                inmo_nombre IN CLIENTES.nombre%TYPE,
                                inmo_direccion IN CLIENTES.direccion%TYPE,
                              	inmo_cif IN CLIENTES.CIF%TYPE,
                                inmo_tef IN CLIENTES.TELEFONO%TYPE,
                                inmo_email IN CLIENTES.EMAIL%TYPE,                                
				                        RSP OUT varchar2,
                                inmo_cliente OUT CLIENTES.codigo_cliente%TYPE
				
);
				

/*Descripcin: 		Baja de un cliente
	
	Parmetro entrada:
						inmo_codcliente: codigo del cliente
	Parmetros de salida:
						RSP
						En caso de baja con xito retorna el cdigo del cliente
	Tareas
					        Se da de baja el cliente
						Se registra accin en la tabla LOG
						Devuelve 
							Si todo ha ido bien:
								RSP = 'OK: Baja cliente con el cdigo del cliente
							Mensajes de error: RSP = 'ERROR: si no existe el cdigo de cliente'*/
       
PROCEDURE INMO_BAJA_CLIENTES (inmo_codcliente IN CLIENTES.CODIGO_CLIENTE%TYPE, RSP OUT VARCHAR2);



/*Descripcin      modificacin de un campo del cliente
  
Parmetro entrada:                              inmo_cod_cliente cdigo del cliente del que se realiza la modificacin
						inmo_nombre nombre del cliente
				                inmo_direccion direccin del cliente
				                inmo_cif cif del cliente
                                                inmo_tef telefono del cliente
                                                inmo_email email del cliente

Parmetro de salida				RSP	
					       En caso de modificacin con exito retorna el codigo de cliente y campo modificado

Tareas						Se modifica el campo del cliente que no tenga valor null en el parmetro de entrada correspondiente
                                                Se registra la accin en la tabla LOG
                                                Devuelve
                                                 si todo ha ido bien RSP='OK: Modificacin del cliente con el cdigo y campo modificado	
						Mensaje de error : RSP=' ERROR: No existe el cliente ' or RSP= 'ERROR :Valor de campo invlido'				


*/	
PROCEDURE INMO_MOD_CLIENTES ( inmo_cod_cliente IN CLIENTES.codigo_cliente%TYPE,
						inmo_nombre IN CLIENTES.nombre%TYPE,
				                inmo_direccion IN CLIENTES.direccion%TYPE,
				                inmo_cif IN CLIENTES.CIF%TYPE,
                                                inmo_tef IN CLIENTES.TELEFONO%TYPE,
                                                inmo_email IN CLIENTES.EMAIL%TYPE,	
						RSP OUT varchar2);
							

/*Descripcin:  	Alta Nueva Sede

Parmetros de entrada:          
				inmo_pais      pais de la sede
        inmo_zona      zona de la sede
        inmo_provincia provincia de la sede
        inmo_poblacion poblacin de la sede
        inmo_direccion    direccin de la sede
				inmo_fecha_ina     fecha de inauguracin de la sede
        inmo_responsable   empleado responsable de la sede
        
				
Parmetros de salida
				RSP
				En caso de insercin con xito retorna el cdigo de la sede,
                                Si la sede existe dispara una excpcin

				
Tareas del procedimiento
				Se da de alta la sede
				Se registra accin en la tabla LOG
				Devuelve Si todo ha ido bien:
					RSP = 'OK: Alta sede con su cdigo
				Mensajes de error:
				'ERROR: hay campos obligatorios sin rellenar'
				'ERROR: La sede  ya existe en el sistema' */
				

PROCEDURE INMO_ALTA_SEDES (
                                inmo_pais IN SEDES.pais%TYPE,
				                        inmo_zona IN SEDES.zona%TYPE,
				                        inmo_provincia IN SEDES.provincia%TYPE,
                                inmo_poblacion IN SEDES.poblacion%TYPE,
                                inmo_direccion IN SEDES.direccion%TYPE, 
                                inmo_fecha_ina IN SEDES.fecha_inauguracion%TYPE,
                                inmo_responsable IN SEDES.responsable%TYPE,
                                RSP OUT varchar2,
                                inmo_sede OUT SEDES.CODIGO_SEDE%TYPE
				
);
				




/*Descripcin      Baja de una sede
  Parmetro entrada:            
                                inmo_cod_sede: codigo de la sede
	        Parmetros de salida:
						RSP
						En caso de baja con xito retorna el cdigo de la sede
	Tareas
					  Se da de baja la sede
						Se registra accin en la tabla LOG
						Devuelve 
							Si todo ha ido bien:
								RSP = 'OK: Baja sede con el cdigo de la sede
							Mensajes de error: RSP = 'ERROR: si no existe el cdigo de la sede
			


*/	

PROCEDURE INMO_BAJA_SEDES (inmo_cod_sede IN SEDES.CODIGO_SEDE%TYPE, RSP OUT VARCHAR2);






/*Descripcin      modificacin de un campo de la sede
  
Parmetro entrada:              inmo_cod_sede Cdigo de la sede
                                inmo_pais Pais de la sede
				                        inmo_zona Zona de la sede
				                        inmo_provincia Provincia de la sede
                                inmo_poblacion Poblacin de la sede
                                inmo_direccion direccin de la sede
                                inmo_fecha_ina fecha inauguracin de la sede
                                inmo_responsable responsable de la sede

Parmetro de salida				RSP	
					       En caso de modificacin con exito retorna el codigo de la sede  y el campo modificado

Tareas						Se modifica el campo de la sede que no tenga valor null en el parmetro de entrada correspondiente
                                                Se registra la accin en la tabla LOG
                                                Devuelve
                                                 si todo ha ido bien RSP='OK: Modificacin de la sede con el cdigo y campo modificado	
						Mensaje de error : RSP=' ERROR: No existe la sede ' or RSP= 'ERROR :Valor de campo invlido'				


*/	

PROCEDURE INMO_MOD_SEDES (
                                inmo_cod_sede IN SEDES.CODIGO_SEDE%TYPE,
				                        inmo_pais IN SEDES.pais%TYPE,
				                        inmo_zona IN SEDES.zona%TYPE,
				                        inmo_provincia IN SEDES.provincia%TYPE,
                                inmo_poblacion IN SEDES.poblacion%TYPE,
                                inmo_direccion IN SEDES.direccion%TYPE, 
                                inmo_fecha_ina IN SEDES.fecha_inauguracion%TYPE,
                                inmo_responsable IN SEDES.responsable%TYPE,
						RSP OUT varchar2);



/*Descripcin:  	Alta Nuevo Inmueble

Parmetros de entrada:         

                                inmo_pais Pais donde se encuentra el inmueble
				                        inmo_zona Zona donde se encuentra el inmueble
				                        inmo_provincia Provincia donde se encuentra el inmueble
                                inmo_poblacion Poblacin donde se encuentra el inmueble
                                inmo_cp Cdigo Postal de la poblacin donde se encuentra el inmueble
                                inmo_direccion direccin donde se encuentra el inmueble   
                                inmo_coor_map coordenadas geagrficas de la ubicacin terrestre del inmueble
                                inmo_fecha_cos fecha de construccin del inmueble
                                inmo_propietario Cdigo cliente propietario del inmueble
                                inmo_tipo Tipo de Inmueble
                                inmo_carac Caractersticas del inmueble			
                                inmo_estado   estado del inmueble 'ALTA' or 'BAJA'
                                
				
Parmetros de salida
				RSP
				En caso de insercin con xito retorna el cdigo del inmueble,
                                Si el inmueble existe dispara una excepcin

				
Tareas del procedimiento
				Se da de alta el inmueble
				Se registra accin en la tabla LOG
        Verifica que existe el tipo de inmueble
        
				Devuelve Si todo ha ido bien:
					RSP = 'OK: Alta inmueble con su cdigo
          Genera un registo de alta en la tabla ACTUACIONES_INMUEBLES (detalle)
				Mensajes de error:
				'ERROR: hay campos obligatorios sin rellenar'
				'ERROR: El inmueble ya existe en el sistema' */
				

PROCEDURE INMO_ALTA_INMUEBLE (
                                inmo_pais IN INMUEBLES.pais%TYPE,
				                        inmo_zona IN INMUEBLES.zona%TYPE,
				                        inmo_provincia IN INMUEBLES.provincia%TYPE,
                                inmo_poblacion IN INMUEBLES.poblacion%TYPE,
                                inmo_cp IN INMUEBLES.CODIGO_POSTAL%TYPE,
                                inmo_direccion IN INMUEBLES.direccion%TYPE,
                                inmo_coor IN INMUEBLES.coordenadas_map%TYPE,
                                inmo_fecha_cons IN INMUEBLES.fecha_construccion%TYPE,
                                inmo_propietario IN INMUEBLES.propietario%TYPE,
                                inmo_tipo IN INMUEBLES.tipo_inmueble%TYPE,
                                inmo_carac IN INMUEBLES.caracteristicas%TYPE,
                                inmo_empleado IN EMPLEADOS.CODIGO_EMPLEADO%TYPE,
				                        RSP OUT varchar2,
                                inmo_cod_inmueble OUT INMUEBLES.CODIGO_INMUEBLE%TYPE
				
);
				

/*Descripcin      Baja de un INMUEBLE
  Parmetro entrada:            
                                inmo_cod_inmueble: codigo del inmueble
	        Parmetros de salida:
						RSP
						En caso de baja con xito retorna el cdigo del inmueble
	Tareas
					  Se da de baja el inmueble y ya no puede generar ninguna actuacion.
						Se registra accin en la tabla LOG
						Devuelve 
							Si todo ha ido bien:
								RSP = 'OK: Baja inmueble con el cdigo del inmueble
                
							Mensajes de error: RSP = 'ERROR: si no existe el cdigo de la sede
			


*/	

PROCEDURE INMO_BAJA_INMUEBLES (inmo_cod_inmueble IN INMUEBLES.CODIGO_INMUEBLE%TYPE, RSP OUT VARCHAR2);






/*Descripcin      modificacin de un campo de la tabla inmuebles
  
Parmetro entrada:              

Parmetro de salida				RSP	= 'OK'
					       En caso de modificacin con exito retorna el codigo de la sede  y el campo modificado

Tareas						Se modifica el campo del inmueble que no tenga valor null en el parmetro de entrada correspondiente
                                                Se registra la accin en la tabla LOG
                                                Devuelve
                                                si todo ha ido bien RSP='OK'	
                                                
						Mensaje de error : RSP=' ERROR: No existe el inmueble ' or RSP= 'ERROR :Valor de campo invlido'				


*/	

PROCEDURE INMO_MOD_INMUEBLES (  
                                inmo_cod_inmueble IN INMUEBLES.codigo_inmueble%TYPE,
                                inmo_pais IN INMUEBLES.pais%TYPE,
				                        inmo_zona IN INMUEBLES.zona%TYPE,
				                        inmo_provincia IN INMUEBLES.provincia%TYPE,
                                inmo_poblacion IN INMUEBLES.poblacion%TYPE,
                                inmo_cp IN INMUEBLES.CODIGO_POSTAL%TYPE,
                                inmo_direccion IN INMUEBLES.direccion%TYPE, 
                                inmo_coor IN INMUEBLES.coordenadas_map%TYPE,
                                inmo_fecha_cons IN INMUEBLES.fecha_construccion%TYPE,
                                inmo_propietario IN INMUEBLES.propietario%TYPE,
                                inmo_tipo IN INMUEBLES.tipo_inmueble%TYPE,
                                inmo_carac IN INMUEBLES.caracteristicas%TYPE,
                                inmo_estado IN INMUEBLES.ESTADO%TYPE,
				                        RSP OUT varchar2
						);



/*Descripcin:  	Alta Nueva Imagen

Parmetros de entrada:          
				inmo_nombre       nombre del fichero de imagen
        inmo_ruta         ubicacin de la imagen
				inmo_inmueble     cdigo del inmueble al que corresponde la imagen
                                
				
Parmetros de salida
				RSP
				En caso de insercin con xito retorna el cdigo de la imagen,
                                Si la imagen existe dispara una excpcin

				
Tareas del procedimiento
				Se da de alta la imagen
				Se registra accin en la tabla LOG
				Devuelve Si todo ha ido bien:
					RSP = 'OK: Alta imagen con su cdigo
				Mensajes de error:
				'ERROR: hay campos obligatorios sin rellenar'
				'ERROR: la imagen  ya existe en el sistema' */
				

PROCEDURE INMO_ALTA_IMAGENES (
         inmo_nombre IN IMAGENES.nombre%TYPE,
				inmo_ruta IN IMAGENES.ruta%TYPE,
				inmo_inmueble IN IMAGENES.CODIGO_INMUEBLE%TYPE,
        inmo_imagen OUT IMAGENES.codigo_imagen%TYPE,
				 RSP OUT varchar2
				
);


/*Descripcin      Baja de una imagen
  Parmetro entrada:            
                                inmo_imagen: codigo de una imagen
	        Parmetros de salida:
						RSP
						En caso de baja con xito retorna el cdigo de la imagen
	Tareas
					  Se da de baja la imagen. En este caso se borra directamente la imagen de la tabla. No tiene ningn tipo de relacin con ninguna otra.
						Se registra accin en la tabla LOG
						Devuelve 
							Si todo ha ido bien:
								RSP = 'OK: Baja sede con el cdigo de la sede
							Mensajes de error: RSP = 'ERROR: si no existe el cdigo de la sede
			


*/	

PROCEDURE INMO_BAJA_IMAGENES (inmo_imagen IN IMAGENES.CODIGO_IMAGEN%TYPE, RSP OUT VARCHAR2);

/*Descripcin      modificacin de un campo de la imagen
  
Parmetro entrada:                              inmo_imagen cdigo de la imagen
						                                    inmo_nombre nombre de la imagen
				                                        inmo_ruta ruta de la imagen
				                
Parmetro de salida				RSP	
					       En caso de modificacin con exito retorna el codigo de cliente y campo modificado

Tareas						                              Se modifica el campo de la imagen que no tenga valor null en el parmetro de entrada correspondiente
                                                Se registra la accin en la tabla LOG
                                                Devuelve
                                                 si todo ha ido bien RSP='OK'	
						Mensaje de error : RSP=' ERROR: No existe la imagen ' or RSP= 'ERROR :Valor de campo invlido'				


*/	
PROCEDURE INMO_MOD_IMAGENES ( inmo_imagen IMAGENES.CODIGO_IMAGEN%TYPE,
                        inmo_nombre IN IMAGENES.nombre%TYPE,
				                inmo_ruta IN IMAGENES.RUTA%TYPE,
				                RSP OUT varchar2);
							





/*Descripcin:  	Alta Nueva Actuacin sobre un Inmueble

Parmetros de entrada:         

                                inmo_tipo_actuacion Tipo de actuacin que se realiza sobre el inmueble
				                        inmo_propietario Propietario del inmueble
				                        inmo_interesado Interesado en el inmueble
                                inmo_empleado Empleado comercial que gestiona la actuacin
                                inmo_fecha_alta Fecha del Alta de la actuacin en el sistema
                                inmo_fecha_fin Fecha de finalizacin de la actuacin
                                inmo_situacion Situacin actual de la actuacin
                                inmo_inmueble Inmueble sobre el que se realiza la actuacin
                                inmo_observaciones Observaciones de la actuacin
                              
                                
				
Parmetros de salida
				RSP
				En caso de insercin con xito retorna el cdigo de la actuacin,Si la actuacin existe dispara una excepcin

				
Tareas del procedimiento
        Verifica que existe el tipo de actuacin, el propietario,el cdigo de empleado y el inmueble que son los campos obligatorios
				Se da de alta la actuacin
        Se registra accin en la tabla LOG
                
				Devuelve Si todo ha ido bien:
					RSP = 'OK: Alta inmueble con su cdigo
          Se reliza la llamada a los procedimientos estadsticos correspondinetes
				Mensajes de error:
				'ERROR: hay campos obligatorios sin rellenar'
				'ERROR: La actuacin  ya existe en el sistema' */
				

PROCEDURE INMO_ALTA_ACTUACION_INMUEBLE (
                                inmo_tipo_actuacion IN ACTUACIONES_INMUEBLES.CODIGO_TIPO_ACTUACION%TYPE,
				                        inmo_propietario IN ACTUACIONES_INMUEBLES.CODIGO_PROPIETARIO%TYPE,
				                        inmo_interesado IN ACTUACIONES_INMUEBLES.CODIGO_INTERESADO%TYPE,
                                inmo_empleado IN ACTUACIONES_INMUEBLES.CODIGO_EMPLEADO%TYPE,
                                inmo_fecha_alta IN ACTUACIONES_INMUEBLES.FECHA_ALTA%TYPE,
                                inmo_fecha_fin IN ACTUACIONES_INMUEBLES.FECHA_FINALIZACION%TYPE,
                                inmo_situacion IN ACTUACIONES_INMUEBLES.SITUACION%TYPE,
                                inmo_inmueble IN ACTUACIONES_INMUEBLES.cod_inmueble%TYPE,
                                inmo_importe IN ACTUACIONES_INMUEBLES.importe_actuacion%TYPE,
                                inmo_observaciones IN ACTUACIONES_INMUEBLES.OBSERVACIONES%TYPE,
                                RSP OUT varchar2,
                                inmo_cod_actuacion OUT ACTUACIONES_INMUEBLES.CODIGO_ACTUACION%TYPE
				
);
				
/*Descripcin      Baja de una actuacin sobre un INMUEBLE
  Parmetro entrada:            
                                inmo_actuacion: codigo de la actuacin sobre el inmueble
	        Parmetros de salida:
						RSP
						En caso de baja con xito retorna el cdigo de la actuacin
	Tareas
					  Verifica que la actuacin existe
            La baja de la actuacin no implica eliminar el registro, sino asignarle una fecha de finalizacin
            Se generan las estadsticas
						Se registra accin en la tabla LOG
						Devuelve 
							Si todo ha ido bien:
								RSP = 'OK'              
							Mensajes de error: RSP = 'ERROR: si no existe el cdigo de la actuacin
			


*/	

PROCEDURE INMO_BAJA_ACTUACION_INMUEBLE (inmo_actuacion IN ACTUACIONES_INMUEBLES.CODIGO_ACTUACION%TYPE,inmo_fecha_fin IN ACTUACIONES_INMUEBLES.FECHA_FINALIZACION%TYPE, RSP OUT VARCHAR2);

/*Descripcin      modificacin de un campo de la actuacin sobre un inmueble. La fecha finalizacin no se modifica, sera una baja. La fecha de alta tampoco seri un alta.
  
Parmetro entrada:                              inmo_actuacion cdigo de la actuacin a modificar
						                                    inmo_tipo tipo de la actuacin a modificar
				                                        inmo_propietario propietario de la actuacin a modificar
                                                inmo_interesado interesado de la actuacin a amodificar
                                                inmo_empleado cdigo del empleado que modifica la actuacin.
                                                inmo_situacion situacin de la actuacin a modificar
                                                inmo_inmueble cdigo del inmueble de la actuacin a modificar
                                                inmo_importe importe a modificar en la actuacin.
                                                inmo_observaciones observaciones de la actuacin.
				                
Parmetro de salida				RSP	
					              En caso de modificacin con exito retorna 'OK'

Tareas						                              Se modifica el campo de la actuacion que no tenga valor null en el parmetro de entrada correspondiente
                                                Se registra la accin en la tabla LOG
                                                Devuelve
                                                 si todo ha ido bien RSP='OK'	
						Mensaje de error : RSP=' ERROR: No existe la actuacin ' or RSP= 'ERROR :Valor de campo invlido'				


*/	




PROCEDURE INMO_MOD_ACTUACION_INMUEBLE (inmo_cod_actuacion IN ACTUACIONES_INMUEBLES.CODIGO_ACTUACION%TYPE,
                                inmo_tipo_actuacion IN ACTUACIONES_INMUEBLES.CODIGO_TIPO_ACTUACION%TYPE,
				                        inmo_propietario IN ACTUACIONES_INMUEBLES.CODIGO_PROPIETARIO%TYPE,
				                        inmo_interesado IN ACTUACIONES_INMUEBLES.CODIGO_INTERESADO%TYPE,
                                inmo_empleado IN ACTUACIONES_INMUEBLES.CODIGO_EMPLEADO%TYPE,
                                inmo_situacion IN ACTUACIONES_INMUEBLES.SITUACION%TYPE,
                                inmo_inmueble IN ACTUACIONES_INMUEBLES.cod_inmueble%TYPE,
                                inmo_importe IN ACTUACIONES_INMUEBLES.importe_actuacion%TYPE,
                                inmo_observaciones IN ACTUACIONES_INMUEBLES.OBSERVACIONES%TYPE,
                                RSP OUT varchar2 );                              
				


END INMO_MOD_GENERAL;