Prompt Creando especificacin del paquete INMO_MOD_PROVEEDORES.................

create or replace PACKAGE INMO_MOD_PROVEEDORES AS 
/*Descripcin:  	Alta Nuevo Proveedor

Parmetros de entrada:         

                                inmo_nombre Nombre del Proveedor
				                        inmo_direccion direccin del proveedor  
                                inmo_clf cif del proveedor
                                inmo_telefono telfono del proveedor
                                inmo_email Email del proveedor
    
Parmetros de salida
				RSP
				En caso de insercin con xito retorna el cdigo del proveedor,
                                Si el proveedor existe dispara una excepcin

				
Tareas del procedimiento
				Se da de alta el proveedor
				Se registra accin en la tabla LOG
   
        
				Devuelve Si todo ha ido bien:
					RSP = 'OK: Alta del proveedor con su cdigo.
         Mensajes de error:
				'ERROR: hay campos obligatorios sin rellenar'
				'ERROR: La actuacin del proveedor ya existe en el sistema' */
				
PROCEDURE INMO_ALTA_PROVEEDOR (
                                inmo_nombre IN PROVEEDORES.NOMBRE%TYPE,
				                        inmo_direccion IN PROVEEDORES.direccion%TYPE,
                                inmo_cif IN PROVEEDORES.CIF%TYPE,
                                inmo_telefono IN PROVEEDORES.TELEFONO%TYPE,
                                inmo_email IN PROVEEDORES.EMAIL%TYPE,
                                RSP OUT varchar2,
                                inmo_cod_proveedor OUT PROVEEDORES.CODIGO_PROVEEDOR%TYPE
				
);
				

/*Descripcin      Baja de un PROVEEDOR
  Parmetro entrada:            
          inmo_cod_proveedor: codigo del proveedor
	        Parmetros de salida:
						RSP
						En caso de baja con xito retorna el cdigo del proveedor
	Tareas
					  Se da de baja el proveedor y ya no puede generar ninguna actuacion.
						Se registra accin en la tabla LOG
						Devuelve 
							Si todo ha ido bien:
								RSP = 'OK: Baja proveedor con el cdigo del proveedor'
                
							Mensajes de error: RSP = 'ERROR: si no existe el cdigo del proveedor
			


*/	

PROCEDURE INMO_BAJA_PROVEEDOR (inmo_cod_proveedor IN PROVEEDORES.CODIGO_PROVEEDOR%TYPE, RSP OUT VARCHAR2);






/*Descripcin      modificacin de un campo de la tabla PROVEEDORES
  
Parmetro entrada:              

Parmetro de salida				RSP	= 'OK'
					       En caso de modificacin con exito retorna el codigo del proveedor  y el campo modificado

Tareas						Se modifica el campo del proveedor que no tenga valor null en el parmetro de entrada correspondiente
                                                Se registra la accin en la tabla LOG
                                                Devuelve
                                                si todo ha ido bien RSP='OK'	
                                                
						Mensaje de error : RSP=' ERROR: No existe el proveedor ' or RSP= 'ERROR :Valor de campo invlido'				


*/	

PROCEDURE INMO_MOD_PROVEEDOR (  
                                inmo_cod_proveedor IN PROVEEDORES.CODIGO_PROVEEDOR%TYPE,
                                inmo_nombre IN PROVEEDORES.NOMBRE%TYPE,
				                        inmo_direccion IN PROVEEDORES.direccion%TYPE,
                                inmo_cif IN PROVEEDORES.CIF%TYPE,
                                inmo_telefono IN PROVEEDORES.TELEFONO%TYPE,
                                inmo_email IN PROVEEDORES.EMAIL%TYPE,
				                        RSP OUT varchar2
						);

/*Descripcin:  	Alta Nueva Actuacin Proveedor

Parmetros de entrada:         

                                inmo_tipo Tipo de la Actuacin del Proveedor
				                        inmo_proveedor cdigo del proveedor  
                                inmo_empleado cdigo del empleado
                                inmo_fecha_alta fecha alta de la actuacin.
                                inmo_fecha_fin fecha de finalizacin de la actuacin del proveedor
                                inmo_situacion situacin actual de la actuacin
                                inmo_actuacion_inmo cdigo de la actuacin inmobiliaria.
                                inmo_observaciones observaciones de la actuacin del proveedor.
                                
    
Parmetros de salida
				RSP
				En caso de insercin con xito retorna el cdigo de la actuacin del proveedor,
                                Si la actuacin del proveedor existe dispara una excepcin

				
Tareas del procedimiento
        Se comprueban que existen los campos que no pueden ser bulos
				Se da de alta el proveedor
				Se registra accin en la tabla LOG
   
        
				Devuelve Si todo ha ido bien:
					RSP = 'OK: Alta de la actuacin del proveedor con su cdigo.
          Mensajes de error:
				'ERROR: hay campos obligatorios sin rellenar'
				'ERROR: El proveedor ya existe en el sistema' */
        
        
        
PROCEDURE INMO_ALTA_ACTUACION_PROVEEDOR ( inmo_tipo_actuacion IN ACTUACIONES_PROVEEDORES.CODIGO_ACTUACION_PRO%TYPE,
                                          inmo_proveedor IN ACTUACIONES_PROVEEDORES.CODIGO_PROVEEDOR%TYPE,
                                          inmo_empleado IN ACTUACIONES_PROVEEDORES.CODIGO_EMPLEADO%TYPE,
                                          inmo_fecha_alta IN ACTUACIONES_PROVEEDORES.FECHA_ALTA_ACTUACION%TYPE,
                                          inmo_fecha_finalizacion IN ACTUACIONES_PROVEEDORES.SITUACION%TYPE,
                                          inmo_situacion IN ACTUACIONES_PROVEEDORES.SITUACION%TYPE,
                                          inmo_actuacion_inmo IN ACTUACIONES_PROVEEDORES.CODIGO_ACTUACION_INMO%TYPE,
                                          inmo_observaciones IN ACTUACIONES_PROVEEDORES.OBSERVACIONES%TYPE,
                                          RSP OUT VARCHAR2,
                                          inmo_actuacion_proveedor out ACTUACIONES_PROVEEDORES.CODIGO_ACTUACION_INMO%TYPE);
   
 
/*Descripcin      Baja de un actuacin de un PROVEEDOR
  Parmetro entrada:            
          inmo_actuacion_proveedor: codigo de la actuacion del proveedor
	        Parmetros de salida:
						RSP
						En caso de baja con xito retorna el cdigo de la actuacin del proveedor
	Tareas
					  Se verifica que la actuacin existe
            Se da de baja la actuacin del proveedore poniendo una fecha de finalizacin
						Se registra accin en la tabla LOG
						Devuelve 
							Si todo ha ido bien:
								RSP = 'OK: Baja proveedor con el cdigo de la actuacin y la fecha de baja'
                
							Mensajes de error: RSP = 'ERROR: si no existe el cdigo de la actuacin.
			
*/	

PROCEDURE INMO_BAJA_ACTUACION_PROVEEDOR (inmo_actuacion_proveedor IN ACTUACIONES_PROVEEDORES.CODIGO_PROVEEDOR%TYPE, RSP OUT VARCHAR2);



/*Descripcin      modificacin de un campo de la actuacin de un proveedor
  
Parmetro entrada:              

Parmetro de salida				RSP	= 'OK'
					       En caso de modificacin con exito retorna el codigo de la actuacin del proveedor  y el campo modificado

Tareas						Se modifica el campo del proveedor que no tenga valor null en el parmetro de entrada correspondiente
                                                Se registra la accin en la tabla LOG
                                                Devuelve
                                                si todo ha ido bien RSP='OK'	
                                                
						Mensaje de error : RSP=' ERROR: No existe la actuacin del proveedor ' or RSP= 'ERROR :Valor de campo invlido'				


*/	 
PROCEDURE INMO_MOD_ACTUACION_PROVEEDOR (  inmo_actuacion_proveedor IN  ACTUACIONES_PROVEEDORES.CODIGO_ACTUACION_PRO%TYPE,
                                          inmo_tipo_actuacion IN ACTUACIONES_PROVEEDORES.CODIGO_ACTUACION_PRO%TYPE,
                                          inmo_proveedor IN ACTUACIONES_PROVEEDORES.CODIGO_PROVEEDOR%TYPE,
                                          inmo_empleado IN ACTUACIONES_PROVEEDORES.CODIGO_EMPLEADO%TYPE,
                                           inmo_situacion IN ACTUACIONES_PROVEEDORES.SITUACION%TYPE,
                                          inmo_actuacion_inmo IN ACTUACIONES_PROVEEDORES.CODIGO_ACTUACION_INMO%TYPE,
                                          inmo_observaciones IN ACTUACIONES_PROVEEDORES.OBSERVACIONES%TYPE,
                                          RSP OUT VARCHAR2 );
   
END INMO_MOD_PROVEEDORES;