SET SERVEROUTPUT ON SIZE 100000;
prompt ################################################################################################################
prompt Generando estadsticas Consulta1: Dado un ao cualquiera, porcentaje de inmuebles a alquilar que dispona la empresa y que se alquilaron durante ese ao...........
select ANIO,trunc(((num_inmuebles_alquilados/num_inmuebles_alquilar) * 100),2) ||'%' AS PORCENTAJE  from dwh_inmuebles_alquilar where (num_inmuebles_alquilar <> 0) ;

prompt  Consulta1: Para un ao determinado..................
select ANIO,trunc(((num_inmuebles_alquilados/num_inmuebles_alquilar) * 100),2) ||'%' AS PORCENTAJE  from dwh_inmuebles_alquilar where (num_inmuebles_alquilar <> 0) 
       and ANIO='2016';

prompt ###############################################################################################################
prompt Generanda estadsticas Consulta2: Comercial que en el momento de reaizar la consulta tiene un porcentaje de xito mejor. Considerando
prompt porcentaje de xito la ratio entre propuestas aceptadas y propuestas presentadas.

select COD_EMPLEADO as Empleado, Ratio||'%' AS RATIO from DWH_PRESENTADAS_ACEPTADAS WHERE MAYOR = 'TRUE';


prompt ################################################################################################################
prompt Generando estadsticas Consulta3:Dado un ao concreto,importe total de las propuestas aceptadas por alguno de nuestros clientes.

select IMPORTE_TOTAL || ' ' AS IMPORTETOTAL FROM DWH_IMPORTE_ACEPTADAS WHERE ANIO = '2016';

select IMPORTE_TOTAL || ' ' AS IMPORTETOTAL FROM DWH_IMPORTE_ACEPTADAS WHERE ANIO= '2017';



prompt ########################################################################################################
PROMPT Generando estadsticas Consulta4 Data warehouse: Sede que en el ao en curso ha realizado un mayor nmero de transacciones, considerando como transaccin la venta o alquiler de un inmueble.........
select distinct cod_sede from dwh_transacciones_visitas where COD_SEDE_MAX='TRUE';

Prompt Completendo Informacin Consulta 4.......
select DISTINCT COD_SEDE,PAIS,ZONA,PROVINCIA,POBLACION,SUBSTR(DIRECCION,1,100 ) as DIRECCION 
      from SEDES, DWH_TRANSACCIONES_VISITAS where (SEDES.CODIGO_SEDE= DWH_TRANSACCIONES_VISITAS.COD_SEDE) AND
         ( DWH_TRANSACCIONES_VISITAS.COD_SEDE_MAX='TRUE');
 
         
prompt ##########################################################################################################
Prompt Generando estadsticas Consulta5 Data WareHouse: Comercial que ms visitas ha realizado en el ao en curso

select distinct cod_empleado from dwh_transacciones_visitas where cod_empleado_max= 'TRUE';

prompt Completando informacin Consulta5  ......

SELECT DISTINCT COD_EMPLEADO,NOMBRE,DOCUMENTO_IDENTIDAD,SUBSTR(DIRECCION,1,100) AS DIRECCION
   FROM EMPLEADOS,DWH_TRANSACCIONES_VISITAS WHERE 
       ( DWH_TRANSACCIONES_VISITAS.COD_EMPLEADO = EMPLEADOS.CODIGO_EMPLEADO) AND (DWH_TRANSACCIONES_VISITAS.COD_EMPLEADO_MAX ='TRUE');

prompt ################################################################################################
prompt Generando estadsticas Consulta6 Data WareHouse: Porcentaje de incremento respecto al mismo mes del ao anterior de los servicios solicitados a proveedores

select TRUNC(((num_actuaciones - num_actuaciones_anterior)/num_actuaciones_anterior) *100,2) || '%'   as PORCENTAJE_INCREMENTO FROM DWH_PORCENTAJE_PROVEEDORES WHERE ANIO='2016' AND MES='12';

select TRUNC(((num_actuaciones - num_actuaciones_anterior)/num_actuaciones_anterior) *100,2) || '%'   as PORCENTAJE_INCREMENTO FROM DWH_PORCENTAJE_PROVEEDORES WHERE ANIO='2015' AND MES='12';

select TRUNC(((num_actuaciones - num_actuaciones_anterior)/num_actuaciones_anterior) *100,2) || '%'   as PORCENTAJE_INCREMENTO FROM DWH_PORCENTAJE_PROVEEDORES WHERE ANIO='2017' AND MES='11';
         

       
prompt #######################################################################################################
prompt Generando estadsticas Consulta7: Por cada sede y ao porcentaje de inmuebles alquilados y vendidos.

SELECT ANIO,COD_SEDE, TRUNC(((NUM_TRAN_SEDE_ANIO/NUM_TOTAL_TRAN)*100),2)||'%' AS PORCENTAJE FROM DWH_PORCENTAJE_TRANSACCIONES ORDER BY COD_SEDE,ANIO;

prompt ########################################################################################################
prompt Generando estadsticas Consulta8: Dado un ao cualquiera, porcentaje de inmuebles vendidos sobre los que la empresa realiza tareas de gestin posterior a la venta.
select ANIO,trunc(((num_vendidos_post/num_total) * 100),2) ||'%' AS PORCENTAJE from DWH_PORCENTAJE_POSTERIOR_VENTA WHERE ANIO='2016';

--#########################################################################################################
prompt Generando estadsticas Consulta 9: Pais que en el ao en curso lleva un mayor nmero de transacciones......
SELECT  DISTINCT PAIS ||' ES EL PAIS CON MAYOR NMERO DE TRANSACCIONES' AS PAIS FROM DWH_PORCENTAJE_TRANSACCIONES WHERE PAIS_MAYOR = 'TRUE';

prompt ###########################################################################################################
PROMPT Generando Estadsticas Consulta 10 Data WareHouse: Tipo de inmueble que ms se ha alquilado en cada uno de los pases en los que la empresa tiene sede..........

select A.DESCRIPCION AS TIPO_INMUEBLE_MAS_ALQUILADO,B.PAIS FROM DWH_TIPOINMUEBLE_MASALQUILADO A, DWH_MAXIMOS_PAIS_INMUEBLE B
   WHERE ( A.NUM_TOTAL_ALQUILERES = B.MAXTOTAL) AND  (A.PAIS = B.PAIS);
   
prompt ########################################################################################################################
prompt Generando Estadsticas Consulta 11 DataWareHouse : nmero total de personas contratadas en cada uno de los paises en el momento de realizar la consulta

select NUM_TOTAL_CONTRATADOS as PERSONAS_CONTRATADAS, PAIS FROM DWH_CONTRATADOS_PAISES;

prompt ##########################################################################################################################
PROMPT Generando estadsticas Consulta 12 DataWareHouse : Cliente que ms litigios jurdicos haya presentado contra la empresa.
select 'EL CLIENTE '|| cod_cliente AS CLIENTE,'HA PRESENTADO LITIGIOS JURDICOS: '||num_total_litigios AS LITIGIOS_JURIDICOS from DWH_LITIGIOS_JURIDICOS
       WHERE ES_MAYOR ='TRUE';
   

    
prompt ##########################################################################################################################
PROMPT Generando estadsticas Consulta 13 Data WareHouse: En el ao en curso, cliente que ms ha facturado a la empresa por cualquier concepto....
select cod_cliente from dwh_facturacion_cliente where mayor_fac='TRUE';

prompt Generando estadisticas Consulta 13 con ms informacin......................
select nombre,substr(direccion,1,100)as direccion,cif from clientes, dwh_facturacion_cliente where 
   ( clientes.codigo_cliente= dwh_facturacion_cliente.cod_cliente) AND dwh_facturacion_cliente.mayor_fac = 'TRUE';

prompt ##########################################################################################################################   
PROMPT Generando estadsticas Consulta14: En una sede concreta, nmero de inmuebles disponibles en este momento.....

select COD_SEDE AS SEDE, NUM_TOTAL_INMUEBLES AS INMUEBLES_DISPOIBLES from dwh_inmuebles_disponibles where cod_sede= 'SED/0001';

select COD_SEDE AS SEDE, NUM_TOTAL_INMUEBLES AS INMUEBLES_DISPOIBLES from dwh_inmuebles_disponibles where cod_sede= 'SED/0007';

select COD_SEDE AS SEDE, NUM_TOTAL_INMUEBLES AS INMUEBLES_DISPOIBLES from dwh_inmuebles_disponibles where cod_sede= 'SED/0003';

select COD_SEDE AS SEDE, NUM_TOTAL_INMUEBLES AS INMUEBLES_DISPOIBLES from dwh_inmuebles_disponibles where cod_sede= 'SED/0006';
